/* Soubor je ulozen v kodovani UTF-8.
 * Kontrola kódování: Příliš žluťoučký kůň úpěl ďábelské ódy.
 */
package cz.pecinovsky.english.pojj.adv_framework.game_gui;

import cz.pecinovsky.english.pojj.adv_framework.game_txt.IAuthor;
import cz.pecinovsky.english.pojj.adv_framework.game_txt.IGame;

import java.net.URL;

import java.util.Collection;

import javax.swing.ImageIcon;



/*******************************************************************************
 * Instance rozhraní {@code IGameG} mají na starosti logiku hry.
 * Jsou schopny akceptovat jednotlivé příkazy a poskytovat informace
 * o průběžném stavu hry a jejích součástech.
 *
 * @author    Rudolf PECINOVSKÝ
 * @version   5.0
 */
public interface IGameG extends IGame, IAuthor
{
//== VEŘEJNÉ KONSTANTY =========================================================
//== DEKLAROVANÉ METODY ========================================================

    /***************************************************************************
     * Vrátí vstupní znakový proud obsahující stránku s nápovědou.
     *
     * @return Požadovaný odkaz
     */
//    @Override
    public URL getHelpURL();


    /***************************************************************************
     * Vrátí obrázek s plánkem prostoru, v němž se hraje.
     *
     * @return Požadovaný odkaz
     */
//    @Override
    public ImageIcon getMap();


    /***************************************************************************
     * Vrátí odkaz na přepravku s názvy příkazů pro přesun do jiné místnosti,
     * zvednutí předmětu a jeho položení.
     *
     * @return Požadovaný odkaz
     */
//    @Override
    public Commands getBasicCommands();


    /***************************************************************************
     * Přidá zadaného posluchače do seznamu posluchačů,
     * které informuje o změně množiny objektů v batohu.
     *
     * @param listener Přihlašovaný posluchač
     */
//    @Override
    public void addBagListener(IListener<IBagG> listener);


    /***************************************************************************
     * Odebere zadaného posluchače ze seznamu posluchačů,
     * které informuje o změně množiny objektů v batohu.
     *
     * @param listener Odhlašovaný posluchač
     */
//    @Override
    public void removeBagListener(IListener<IBagG> listener);


    /***************************************************************************
     * Přidá zadaného posluchače do seznamu posluchačů,
     * které informuje o změně množiny objektů v aktuální prostoru.
     *
     * @param listener Přihlašovaný posluchač
     */
//    @Override
    public void addObjectListener(IListener<IPlaceG> listener);


    /***************************************************************************
     * Odebere zadaného posluchače ze seznamu posluchačů,
     * které informuje o změně množiny objektů v aktuálním prostoru.
     *
     * @param listener Odhlašovaný posluchač
     */
//    @Override
    public void removeObjectListener(IListener<IPlaceG> listener);


    /***************************************************************************
     * Přidá zadaného posluchače do seznamu posluchačů,
     * které informuje o změně množiny sousedů aktuálního prostoru.
     *
     * @param listener Přihlašovaný posluchač
     */
//    @Override
    public void addNeighborsListener(IListener<IPlaceG> listener);


    /***************************************************************************
     * Odebere zadaného posluchače ze seznamu posluchačů,
     * které informuje o změně množiny sousedů aktuálního prostoru.
     *
     * @param listener Odhlašovaný posluchač
     */
//    @Override
    public void removeNeighborsListener(IListener<IPlaceG> listener);


    /***************************************************************************
     * Přidá zadaného posluchače do seznamu posluchačů,
     * kterým hra oznamuje začátek a konec rozhovoru.
     *
     * @param listener Přihlašovaný posluchač
     */
//    @Override
    public void addDialogListener(IListener<Boolean> listener);


    /***************************************************************************
     * Odebere zadaného posluchače ze seznamu posluchačů,
     * kterým hra oznamuje začátek a konec rozhovoru.
     *
     * @param listener Odhlašovaný posluchač
     */
//    @Override
    public void removeDialogListener(IListener<Boolean> listener);



//== ZDĚDĚNÉ METODY ============================================================

    //Metody her implementujících toto rozhraní musejí vracet instance,
    //resp. kolekce instancí implementujících rozhraní v tomto balíčku
    //Proto je třeba je tu deklarovat znovu. protože deklarované
    //návratové hodnoty jsou potomky návratových hodnot metod rodiče

    /***************************************************************************
     * Vrátí odkaz na aktuální místnost,
     * tj. na místnost, v niž se pravé nachází hráč.
     *
     * @return Požadovaný odkaz
     */
    @Override
    public IPlaceG getActualPlace();


    /***************************************************************************
     * Vrátí odkaz na batoh, do nějž bude hráč ukládat sebrané předměty.
     *
     * @return Požadovaný odkaz
     */
    @Override
    public IBagG getBag();


    /***************************************************************************
     * Vrátí kolekci odkazů na jednotlivé místnosti.
     *
     * @return Požadovaná kolekce
     */
    @Override
    public Collection<? extends IPlaceG> getAllPlaces();



//== VNOŘENÉ TŘÍDY =============================================================
}
