/* Soubor je ulozen v kodovani UTF-8.
 * Kontrola kódování: Příliš žluťoučký kůň úpěl ďábelské ódy.
 */
package cz.pecinovsky.english.pojj.adv_framework.test_util;

import cz.pecinovsky.english.pojj.adv_framework.game_gui.IGameG;
import cz.pecinovsky.english.pojj.adv_framework.game_gui.IUIG;

import cz.pecinovsky.english.pojj.adv_framework.scenario.Scenario;



/*******************************************************************************
 * Instance třídy {@code _Test_115} testují dvojici objektů
 * představujících hru a grafické uživatelské rozhraní.
 * Umožňují je otestovat jak samostatně, tak ve vzájemné souhře.
 *
 * @author    Rudolf PECINOVSKÝ
 * @version   0.00.000
 */
public class _Test_115 extends Triumvirate
{
//== KONSTANTNÍ ATRIBUTY TŘÍDY =================================================
//== PROMĚNNÉ ATRIBUTY TŘÍDY ===================================================
//== STATICKÝ INICIALIZAČNÍ BLOK - STATICKÝ KONSTRUKTOR ========================
//== KONSTANTNÍ ATRIBUTY INSTANCÍ ==============================================

    /** Testované GUI. */
    private final IUIG thisGUI;



//== PROMĚNNÉ ATRIBUTY INSTANCÍ ================================================
//== PŘÍSTUPOVÉ METODY VLASTNOSTÍ TŘÍDY ========================================
//== OSTATNÍ NESOUKROMÉ METODY TŘÍDY ===========================================

    /***************************************************************************
     * Prověří, jestli zadaná hra vyhovuje požadavkům rozhraní {@code IGameG},
     * a oznámí výsledek.
     *
     * @param game Prověřovaná hra
     * @return Dopadnou-li dobře všechny testy, vrátí {@code true},
     *         jinak vrátí {@code false}
     */
    public static boolean verifyGame(IGameG game)
    {
        _Test_115 test = _Test_115.getInstance(game);
        return test.verifyGame();
    }



//##############################################################################
//== KONSTRUKTORY A TOVÁRNÍ METODY =============================================

    /***************************************************************************
     * Vytvoří testovací instanci pro testování možnosti
     * spouštět zadanou hru na implicitním GUI.
     *
     * @param gameClass Testovaná třída
     * @return Vráti požadovanou testovací instanci
     */
    public static _Test_115 getInstance(Class<? extends IGameG> gameClass)
    {
        IGameG    game = (IGameG) _Test_101.getInstanceOfGame(gameClass);
        _Test_115 test = new _Test_115(game, getDefaultGUI());
        return test;
    }


    /***************************************************************************
     * Vytvoří testovací instanci pro testování možnosti
     * spouštět zadanou hru na zadaném GUI.
     *
     * @param game Testovaná hra
     * @param gui  Testované GUI
     * @return Vráti požadovanou testovací instanci
     */
    public static _Test_115 getInstance(IGameG game, IUIG gui)
    {
        return new _Test_115(game, gui);
    }


    /***************************************************************************
     * Vytvoří testovací instanci pro testování možnosti
     * spouštět zadanou hru na implicitním GUI.
     *
     * @param game Testovaná hra
     * @return Vráti požadovanou testovací instanci
     */
    public static _Test_115 getInstance(IGameG game)
    {
        return new _Test_115(game, getDefaultGUI());
    }


    /***************************************************************************
     * Vytvoří testovací instanci pro testování možnosti
     * spouštět implicitní hru na zadaném GUI.
     *
     * @param gui  Testované GUI
     * @return Vráti požadovanou testovací instanci
     */
    public static _Test_115 getInstance(IUIG gui)
    {
        return new _Test_115(getDefaultGame(), gui);
    }


    /***************************************************************************
     * Vytvoří testovací instanci pro testování možnosti
     * spouštět zadanou hru na zadaném GUI.
     *
     * @param game Testovaná hra
     * @param gui  Testované GUI
     */
    private _Test_115(IGameG game, IUIG gui)
    {
        super(fromGame(game));
        verifyImplementsIGameG();
        this.thisGUI = gui;
    }



//== ABSTRAKTNÍ METODY =========================================================
//== PŘÍSTUPOVÉ METODY VLASTNOSTÍ INSTANCÍ =====================================
//== OSTATNÍ NESOUKROMÉ METODY INSTANCÍ ========================================

    /***************************************************************************
     * Zahraje na daném GUI danou hru
     * podle scénáře určeného pro testování GUI.
     */
    public void playGameByTestScenario()
    {
        playGameByScenario(gameG, manager.getGuiTestScenario(), thisGUI);
    }


    /***************************************************************************
     * Zahraje na daném GUI danou hru
     * podle scénáře se zadaným indexem.
     *
     * @param i  Index scénáře, podle nějž se hra bude hrát
     */
    public void playGameByScenario(int i)
    {
        playGameByScenario(gameG, manager.getScenario(i), thisGUI);
    }


    /***************************************************************************
     * Zahraje na daném GUI danou hru
     * podle scénáře se zadaným názvem.
     *
     * @param name Název scénáře, podle nějž se hra bude hrát
     */
    public void playGameByScenario(String name)
    {
        playGameByScenario(gameG, manager.getScenario(name), thisGUI);
    }


    /***************************************************************************
     * Zahraje na daném GUI danou hru
     * podle zadaného scénáře.
     *
     * @param scenario Scénář, podle nějž se hra bude hrát
     */
    public void playGameByScenario(Scenario scenario)
    {
       playGameByScenario(gameG, scenario, thisGUI);
    }


    /***************************************************************************
     * Prověří, zda daná hra vyhovuje požadavkům rozhraní {@code IGameG},
     * a vrátí informaci o výsledku provedených testů.
     * 
     * @return Dopadnou-li dobře všechny testy, vrátí {@code true},
     *         jinak vrátí {@code false}
     */
    public boolean verifyGame()
    {
        GameGClassTest gameClassTest = new GameGClassTest(getCrate());
        return gameClassTest.verifyGame();
    }



//== SOUKROMÉ A POMOCNÉ METODY TŘÍDY ===========================================
//== SOUKROMÉ A POMOCNÉ METODY INSTANCÍ ========================================
//== INTERNÍ DATOVÉ TYPY =======================================================
//== TESTY A METODA MAIN =======================================================
//
//    /***************************************************************************
//     * Testovací metoda.
//     */
//    public static void test()
//    {
//        _Test_115 inst = new _Test_115();
//    }
//    /** @param args Parametry příkazového řádku - nepoužívané. */
//    public static void main( String[] args )  {  test();  }
}
