/* Soubor je ulozen v kodovani UTF-8.
 * Kontrola kódování: Příliš žluťoučký kůň úpěl ďábelské ódy.
 */
package cz.pecinovsky.english.pojj.adv_framework.test_util.default_game.hra;

import cz.pecinovsky.english.pojj.adv_framework.game_gui.IListener;
import cz.pecinovsky.english.pojj.adv_framework.game_gui.IPlaceG;

import java.awt.Point;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


import static cz.pecinovsky.english.pojj.adv_framework.test_util.default_game.
              hra.Předmět.TĚŽKÝ;

import static cz.pecinovsky.english.pojj.adv_framework.test_util.default_game.
              hra.Texty.*;



/*******************************************************************************
 * Instance třídy {@code Místnost} představují jednotlive mistnosti
 * v prochazenem byte. Trida {@code Místnost} je soucasne schopna vybudovat
 * na zákadě zadných parametrů cely byt z jednotlivych mistnosti.
 *
 * @author    Rudolf PECINOVSKY
 * @version   5.0
 */
public enum Místnost implements IPlaceG
{
//== HODNOTY VÝČTOVÉHO TYPU ====================================================

    /** Vstupní mistnost bytu odkud  se dá přesunout do většiny místností. */
    Předsíň (new Point(550, 300),
        "Vstupní místnost bytu odkud  se dá přesunout do většiny místností.",
        new String[] { LOŽNICE, OBÝVÁK, KOUPELNA },
        TĚŽKÝ+BOTNÍK, DEŠTNÍK
//        new String[] { "Ložnice", "Obývák", "Koupelna" },
//        TĚŽKÝ+"Botník", "Deštník"
    ),

    /** Koupelna spojená se záchodem. */
    Koupelna (new Point(570, 100),
        "Koupelna spojená se záchodem.",
        new String[] { PŘEDSÍŇ },
        BRÝLE, TĚŽKÝ+UMYVADLO, ČASOPIS
//        new String[] { "Předsíň" },
//        "Brýle", TĚŽKÝ+"Umyvadlo", "Časopis"
    ),

    /** Druhá nejmilejší mistnost v bytě, v níž osazenstvo tráví
     *  mnohé příjemné chvilky. */
    Ložnice (new Point(460, 100),
        "Druhá nejmilejší místnost v bytě, v níž osazenstvo tráví " +
        "mnohé příjemné chvilky.",
        new String[] { KUCHYŇ, PŘEDSÍŇ },
        TĚŽKÝ+POSTEL, TĚŽKÝ+ZRCADLO, ŽUPAN
//        new String[] { "Kuchyň", "Předsíň" },
//        TĚŽKÝ+"Postel", TĚŽKÝ+"Zrcadlo", "Župan"
    ),

    /** Místnost, ve které se moc nezdržuju. */
    Obývák (new Point(200, 300),
        "Místnost, ve které se moc nezdržuju.",
        new String[] { KUCHYŇ, PŘEDSÍŇ },
        TĚŽKÝ+TELEVIZE
//        new String[] { "Kuchyň", "Předsíň" },
//        TĚŽKÝ+"Televize"
    ),

    /** Moje nejoblíbenější mistnost. */
    Kuchyň (new Point(200, 100),
        "Moje nejoblíbenější místnost.",
        new String[] { LOŽNICE, OBÝVÁK },
        TĚŽKÝ+LEDNIČKA, PAPÍR
//        new String[] { "Ložnice", "Obývák" },
//        TĚŽKÝ+"Lednička", "Papír"
    ),

    /** Nejčastější cíl mých výletů. */
    Lednička (new Point(30, 30),
        "Nejčastější cíl mých výletů.",
        new String[] {},
        "@"+PIVO, "@"+PIVO, "@"+PIVO, SALÁM, HOUSKA, "@"+VÍNO, "@"+RUM
//       new String[] {},
//        "@Pivo", "@Pivo", "@Pivo", "Salám", "Houska", "@Víno", "@Rum"
    );



//== KONSTANTNÍ ATRIBUTY TŘÍDY =================================================

    /** Mapa sloužící k převodu názvu místnosti na odpovídající místnost. */
    private static final Map<String,Místnost> název2místnost =
                                              new HashMap<String,Místnost>();

    /** Posluchači očekávající oznámení změně předmětů v místnosti. */
    private static final List<IListener<IPlaceG>> posluchačiPředmětů =
                                            new ArrayList<IListener<IPlaceG>>();

    /** Posluchači očekávající oznámení změně sousedů místnosti. */
    private static final List<IListener<IPlaceG>> posluchačiSousedů =
                                            new ArrayList<IListener<IPlaceG>>();



//== PROMĚNNÉ ATRIBUTY TŘÍDY ===================================================

    private static Místnost aktuálníMístnost;



//== STATICKÝ INICIALIZAČNÍ BLOK - STATICKÝ KONSTRUKTOR ========================

    //Teprve nyní existují všechny instance i všechny potřebné kontejnery,
    //a proto lze teprve nyní inicializovat sousedy místností
    static {
        //Zapamatuji si jména všech místností malými písmeny
        for (Místnost m : values()) {
            název2místnost.put(m.name().toLowerCase(), m);
        }
        //Jména výchozích sousedů převedu na sousedy a ty uložím
        for (Místnost m : values()) {
            for (int i=0;   i < m.názvyVýchozíchSousedů.length;   i++) {
                m.výchozíSousedé[i] = název2místnost.get(
                                      m.názvyVýchozíchSousedů[i].toLowerCase());
            }
            m.názvyVýchozíchSousedů = null;  //Už nebudou potřeba
        }
        inicializuj();
    }



//== KONSTANTNÍ ATRIBUTY INSTANCÍ ==============================================

    /** Popis významu a účelu dané místnosti. */
    private final String popis;

    /** Sousedé místnosti na začátku hry. */
    private final Místnost[] výchozíSousedé;

    /* Předměty v místnosti na počátku hry. */
    private final Předmět[] výchozíPředměty;

    /** Aktuální sousedé dané místnosti. */
    private final Collection<Místnost> sousedé  = new ArrayList<Místnost>();

    /** Předměty nacházející se aktuálně v místnosti. */
    private final Collection<Předmět>  předměty = new ArrayList<Předmět>();

    /** Pozice místnosti na plánku hry. */
    private final Point pozice;



//== PROMĚNNÉ ATRIBUTY INSTANCÍ ================================================

    /** Pomocná proměnná používaná v konstruktoru třídy
     *  pro inicializaci pole výchozíSousedé. */
    private String[] názvyVýchozíchSousedů;



//== PŘÍSTUPOVÉ METODY ATRIBUTŮ TŘÍDY ==========================================

    /***************************************************************************
     * Vrátí odkaz na aktuálni místnost,
     * tj. na místnost, v níž se právě nachází hráč.
     *
     * @return Požadovaný odkaz
     */
    static Místnost getAktuálníMístnost()
    {
        return aktuálníMístnost;
    }


    /***************************************************************************
     * Nastaví zadanou místnost jako aktuální.
     *
     * @param místnost Nastavovaná aktuální místnost
     */
    static void setAktuálníMístnost(Místnost místnost) {
        aktuálníMístnost = místnost;
        obvolejPosluchače();
    }


    /***************************************************************************
     * Vrátí odkaz na místnost se zadaným názvem.
     *
     * @param název Název hledané místnosti
     * @return Požadovaný odkaz
     */
    static Místnost getMístnost(String název)
    {
        Místnost cil = název2místnost.get(název.toLowerCase());
        return cil;
    }


    /***************************************************************************
     * Vrátí kolekci odkazů na jednotlivé místnosti.
     *
     * @return Požadovaná kolekce
     */
    static Collection<Místnost> getMístnosti()
    {
        return new ArrayList<Místnost>(Arrays.asList(values()));
    }



//== OSTATNÍ NESOUKROMÉ METODY TŘÍDY ===========================================

    /***************************************************************************
     * Inicializuje místnosti do výchozího stavu pro spuštění hry,
     * tj. nastavuje jim výchozí sousedy a výchozí přítomné předměty.
     * Metoda přitom předpokládá, že jsou již přihlášeni všichni posluchači.
     */
    static void inicializuj()
    {
        for (Místnost m : values()) {
            m.sousedé.clear();
            m.sousedé.addAll(Arrays.asList(m.výchozíSousedé));
            m.předměty.clear();
            m.předměty.addAll(Arrays.asList(m.výchozíPředměty));
        }
        aktuálníMístnost = Předsíň;
        obvolejPosluchače();
    }


    /***************************************************************************
     * Obvolá všechny přihlášené posluchače zadaného stavu,
     * tj. posluchače předmětů i posluchače sousedů,
     * a tím jim oznámí, že se množina sledovaných objektů změnila.
     */
    static void obvolejPosluchače()
    {
        obvolejPosluchače(posluchačiPředmětů);
        obvolejPosluchače(posluchačiSousedů);
    }


    /***************************************************************************
     * Přidá zadaného posluchače do seznamu posluchačů,
     * které zpravuje o změně množiny předmětů v místnosti
     *
     * @param posluchač Přihlašovaný posluchač
     */
    static void přihlašPosluchačePředmětů(IListener<IPlaceG> posluchač)
    {
        posluchačiPředmětů.add(posluchač);
    }


    /***************************************************************************
     * Odebere zadaného posluchače ze seznamu posluchačů,
     * které zpravuje o změně množiny předmětů v místnosti
     *
     * @param posluchač Odhlašovaný posluchač
     */
    static void odhlašPosluchačePředmětů(IListener<IPlaceG> posluchač)
    {
        posluchačiPředmětů.remove(posluchač);
    }


    /***************************************************************************
     * Přidá zadaného posluchače do seznamu posluchačů,
     * které zpravuje o změně množiny sousedů místnosti
     *
     * @param posluchač Přihlašovaný posluchač
     */
    static void přihlašPosluchačeSousedů(IListener<IPlaceG> posluchač)
    {
        posluchačiSousedů.add(posluchač);
    }


    /***************************************************************************
     * Odebere zadaného posluchače ze seznamu posluchačů,
     * které zpravuje o změně množiny sousedů místnosti
     *
     * @param posluchač Odhlašovaný posluchač
     */
    static void odhlašPosluchačeSousedů(IListener<IPlaceG> posluchač)
    {
        posluchačiSousedů.remove(posluchač);
    }



//##############################################################################
//== KONSTRUKTORY A TOVÁRNÍ METODY =============================================

    /***************************************************************************
     * Vytvoří mistnost se zadanými charakteristikami, popisem účelu místnosti,
     * pozicí případného návštěvníka (= pozicí na plánku),
     * seznamem možných sousedů (kam všude se dá z místnosti jít) a
     * seznamem v místnosti se vyskytujících předmětů.
     *
     * @param pozice   Pozice hráče na plánku bytu při pobytu v dané místnosti
     * @param popis    Popis účelu dané místnosti
     * @param sousedé  Pole s názvy sousedů dané místnosti, tj. s názvy
     *                 místností, do nichž se dá z dané místnosti přejít.
     * @param předměty Názvy předmětů, které se v místnosti vyskytují.
     *                 Konstruktor nechá tyto předměty vyrobit.
     */
    private Místnost(Point pozice, String popis,
                     String[] sousedé, String... předměty)
    {
        this.pozice = pozice;
        this.popis  = popis;
        this.názvyVýchozíchSousedů = sousedé;
        this.výchozíSousedé  = new Místnost[sousedé.length];
        this.výchozíPředměty = new Předmět [předměty.length];
        for (int i=0;   i < předměty.length;   i++ ) {
            Předmět předmět = new Předmět(předměty[i]);
            výchozíPředměty[i] = předmět;
        }
    }



//== ABSTRAKTNÍ METODY =========================================================
//== PŘÍSTUPOVÉ METODY INSTANCÍ ================================================

    /***************************************************************************
     * Vrátí název místnosti.
     *
     * @return Název místnosti
     */
    @Override
    public String getName()
    {
        return name();
    }


    /***************************************************************************
     * Vrátí popis místnosti, který danou místnost stručné charakterizuje.
     *
     * @return Pozadovany popis
     */
    @Override
    public String getDescription()
    {
        return popis;
    }


    /***************************************************************************
     * Vrátí kolekci předmětů nacházejících se v dané místnosti.
     *
     * @return Požadovaná kolekce
     */
    @Override
    public Collection<Předmět> getObjects()
    {
        //Vrací nemodifikovatelnou kolekci,
        //aby interně používanou kolekci nebylo možno zvenku změnit
        return Collections.unmodifiableCollection(předměty);
    }


    /***************************************************************************
     * Vrátí kolekci místností, do nichž je možno se z teto místnosti přesunout.
     *
     * @return Požadovaná kolekce
     */
    @Override
    public Collection<Místnost> getNeighbors()
    {
        //Vrací "kopii" požadované kolekce,
    //aby interně používanou kolekci nebylo možno zvenku změnit 
        return new ArrayList<Místnost>(sousedé);
    }


    /***************************************************************************
     * Vrátí pozici místnosti na plánu hry,
     * presněji pozici hráče nacházejícícho se v dané místnosti.
     * Na této pozici bude hráč při pobytu v dané místnosti zobrazen.
     *
     * @return Požadovaná pozice
     */
    @Override
    public Point getPosition()
    {
        return pozice;
    }



//== OSTATNÍ NESOUKROMÉ  METODY INSTANCÍ =======================================

    /***************************************************************************
     * Vrátí název dané instance.
     *
     * @return Nazev instance
     */
    @Override
    public String toString()
    {
        return name();
    }


    /***************************************************************************
     * Odloží zadaný předmět v místnosti.
     *
     * @param  předmět Předmět odkládaný v místnosti
     */
    void polož( Předmět předmět ) {
        předměty.add( předmět );
        obvolejPosluchače(posluchačiPředmětů);
    }


    /***************************************************************************
     * Odebere předmět zadaného názvu z místnosti.
     * Odebrat je možné pouze zvednutelné předměty.
     *
     * @param název  Název odebíraného předmětu
     * @return Byl-li předmět z místnosti odebrán, vrátí tento předmět.
     *         Nebyl-li předmět zvednutelný, vrátí předmět {@link TÍHA}.
     *         Nebyl-li v místnosti požadovaný předmět, vrátí {@code null}.
     */
    Předmět zvedni(String název)
    {
        String jméno;
        Předmět našel = null;
        for( Předmět předmět : předměty ) {
            jméno = předmět.getName();
            if (jméno.equalsIgnoreCase( název ))  {
                if (předmět.isTransportable())  {
                    předměty.remove(předmět);
                    obvolejPosluchače(posluchačiPředmětů);
                    našel = předmět;
                } else {
                    našel = Předmět.TÍHA;
                }
                break;
            }
        }
        return našel;
    }



//== SOUKROMÉ A POMOCNÉ METODY TŘÍDY ===========================================

    /***************************************************************************
     * Obvolá všechny přihlášené posluchače zadaného stavu, čímž jím oznámí,
     * že se množina sledovaných objektů (možná) změnila.
     *
     * @param posluchači Seznam obvolávaných posluchačů
     */
    private static void obvolejPosluchače(
                        Collection<IListener<IPlaceG>> posluchači)
    {
        for ( IListener<IPlaceG> posluchač : posluchači) {
            posluchač.notice(aktuálníMístnost);
        }
    }



//== SOUKROMÉ A POMOCNÉ METODY INSTANCÍ ========================================
//== VNOŘENÉ A VNITŘNÍ TŘÍDY ===================================================
//== TESTOVACÍ METODY A TŘÍDY ==================================================
//
//     /***************************************************************************
//      * Testovací metoda.
//      */
//     public static void test()
//     {
//     }
//     /** @param args Parametry příkazového řádku - nepoužité. */
//     public static void main( String... args ) { test(); }
}
