package cz.pecinovsky.english.pojj.adv_framework.test_util.default_game.hra;

import static cz.pecinovsky.english.pojj.adv_framework.test_util.default_game.
              hra.Texty.*;



/*******************************************************************************
 * Instance třídy {@code PříkazKonec} představuje příkaz k ukončení hry.
 * Zabezpečí, že budou vráceny všechny prostředky a nastaveny příznaky tak,
 * aby hra mohla být znovu odstartována.
 *
 * @author    Rudolf PECINOVSKY
 * @version   4.00,  17.3.2007
 */
public class PříkazKonec extends APříkaz
{
//== KONSTANTNI ATRIBUTY TRIDY =================================================
//== PROMENNE ATRIBUTY TRIDY ===================================================
//== KONSTANTNI ATRIBUTY INSTANCI ==============================================
//== PROMENNE ATRIBUTY INSTANCI ================================================
//== NESOUKROME METODY TRIDY ===================================================

//##############################################################################
//== KONSTRUKTORY A TOVARNI METODY =============================================

    /***************************************************************************
     * Vytrvoří příkaz ukončující hru.
     */
    PříkazKonec()
    {
        super( pKONEC, //"Konec",
               "Ukončí celou hru a vrátí všechny prostředky." );
    }


//== ABSTRAKTNI METODY =========================================================
//== NESOUKROME METODY INSTANCI ================================================

    /***************************************************************************
     * Ukončí hru, uvolní všechny alokované prostředky a připraví vše pro to,
     * aby mohla být hra znovu spuštěna.
     *
     * @param  parametry Nepracuje s zadnymi parametry
     * @return Zprava o ukonceni hry
     */
    @Override
    public String execute( String... parametry )
    {
        DefaultGame.getInstance().stop();
        return zKONEC;
//        return "Konec hry. Děkujeme, že jste zkusil(a) naši hru.";
    }



//== SOUKROME A POMOCNE METODY TRIDY ===========================================
//== SOUKROME A POMOCNE METODY INSTANCI ========================================
//== VNORENE A VNITRNI TRIDY ===================================================
//== TESTY A METODA MAIN =======================================================
}
