/* Soubor je ulozen v kodovani UTF-8.
 * Kontrola kódování: Příliš žluťoučký kůň úpěl ďábelské ódy.
 */
package cz.pecinovsky.english.pojj.adv_framework.test_util.default_gui;

import cz.pecinovsky.english.pojj.adv_framework.game_gui.IBagG;
import cz.pecinovsky.english.pojj.adv_framework.game_gui.IGameG;
import cz.pecinovsky.english.pojj.adv_framework.game_gui.IObjectG;

import java.util.ArrayList;
import java.util.Collection;



/*******************************************************************************
 * Instance třídy {@code PanelBatohuBtn} představují panely,
 * v nichž se v průběhu hry zobrazuje obsah batohu hráče,
 * tj. předměty, které jsou v něm uloženy.
 * <br><br>
 * Třída je upravena tak, aby její instance uměly pracovat s prvky
 * definovanými jako tlačítka, jejichž stiskem lze daný předmět položit.
 * K tomu bylo třeba přidat atributy pro zapamatování si příkazu k položení
 * předmětu a také GUI, jehož prostřednictvím bude příkaz hře zadán.
 *
 * @author    Rudolf PECINOVSKÝ
 * @version   0.00.000
 */
@SuppressWarnings("serial")
class PanelBatohuBtn extends APanelPrvků<IBagG>
{
//== KONSTANTNÍ ATRIBUTY TŘÍDY =================================================
//== PROMĚNNÉ ATRIBUTY TŘÍDY ===================================================
//== STATICKÝ INICIALIZAČNÍ BLOK - STATICKÝ KONSTRUKTOR ========================
//== KONSTANTNÍ ATRIBUTY INSTANCÍ ==============================================

    /** GUI, prostřednictvím nějž je hra ovládána. */
    private final IMojeGUI gui;



//== PROMĚNNÉ ATRIBUTY INSTANCÍ ================================================

    /** Příkaz, jímž se v aktuálně zpracovávané hře pokládá předmět. */
    private String příkazPolož;



//== PŘÍSTUPOVÉ METODY VLASTNOSTÍ TŘÍDY ========================================
//== OSTATNÍ NESOUKROMÉ METODY TŘÍDY ===========================================

//##############################################################################
//== KONSTRUKTORY A TOVÁRNÍ METODY =============================================

    /***************************************************************************
     * Vytoří nový panel pro zobrazení obsahu batohu, přičemž předpokládá,
     * že předměty v batohu budou na panelu zobrazovány jako talčítka,
     * jejichž stiskem můžeme daný předmět položit.
     *
     * @param gui  GUI, prostřednictvím nějž je hra ovládána
     */
    PanelBatohuBtn(IMojeGUI gui)
    {
        super("Obsah batohu");
        this.gui = gui;
    }



//== ABSTRAKTNÍ METODY =========================================================
//== PŘÍSTUPOVÉ METODY VLASTNOSTÍ INSTANCÍ =====================================
//== OSTATNÍ NESOUKROMÉ METODY INSTANCÍ ========================================

    /***************************************************************************
     * Hlášeni o změně obsahu batohu.
     *
     * @param batoh Batoh, jehož obsah se změnil
     */
    @Override
    public void notice(IBagG batoh)
    {
        Collection<PrvekPaneluBtn> prvky = new ArrayList<PrvekPaneluBtn>();
        for (IObjectG předmět : batoh.getObjects()) {
            PrvekPaneluBtn pp = new PrvekPaneluBtn(předmět, příkazPolož, gui);
            prvky.add(pp);
        }
        zpracujHlášení(prvky);
    }


    /***************************************************************************
     * Inicializuje panel pro práci s novou hrou.
     *
     * @param hra Hra, s níž bude panel od této chvíle komunikovat
     */
    @Override
    public void inicializuj(IGameG hra)
    {
        příkazPolož = hra.getBasicCommands().cPUT_DOWN;
        hra.addBagListener(this);
        notice(hra.getBag());    //Kdyby hráč začínal s neprázným batohem
    }



//== SOUKROMÉ A POMOCNÉ METODY TŘÍDY ===========================================
//== SOUKROMÉ A POMOCNÉ METODY INSTANCÍ ========================================
//== INTERNÍ DATOVÉ TYPY =======================================================
//== TESTY A METODA MAIN =======================================================
//
//    /***************************************************************************
//     * Testovací metoda.
//     */
//    public static void test()
//    {
//        PanelBatohu inst = new PanelBatohu();
//    }
//    /** @param args Parametry příkazového řádku - nepoužívané. */
//    public static void main( String[] args )  {  test();  }
}
