/* Soubor je ulozen v kodovani UTF-8.
 * Kontrola kódování: Příliš žluťoučký kůň úpěl ďábelské ódy.
 */
package cz.pecinovsky.english.pojj.adv_framework.test_util.default_gui;

import cz.pecinovsky.english.pojj.adv_framework.game_gui.IGameG;

import javax.swing.Box;
import javax.swing.BoxLayout;



/*******************************************************************************
 * Instance třídy {@code PanelMístností} představují panely,
 * v nichž se v průběhu hry zobrazují předměty v aktuální místnosti
 * a sousedé této místnosti
 *
 * @author    Rudolf PECINOVSKÝ
 * @version   0.00.000
 */
@SuppressWarnings("serial")
public class PanelMístností extends Box
{
//== KONSTANTNÍ ATRIBUTY TŘÍDY =================================================
//== PROMĚNNÉ ATRIBUTY TŘÍDY ===================================================
//== STATICKÝ INICIALIZAČNÍ BLOK - STATICKÝ KONSTRUKTOR ========================
//== KONSTANTNÍ ATRIBUTY INSTANCÍ ==============================================

    /** Panel zobrazující předměty v aktuální místnosti. */
    private final PanelPředmětů panelPředmětů = new PanelPředmětů();

    /** Panel zobrazující předměty v aktuální místnosti. */
    private final PanelSousedů panelSousedů = new PanelSousedů();



//== PROMĚNNÉ ATRIBUTY INSTANCÍ ================================================
//== PŘÍSTUPOVÉ METODY VLASTNOSTÍ TŘÍDY ========================================
//== OSTATNÍ NESOUKROMÉ METODY TŘÍDY ===========================================

//##############################################################################
//== KONSTRUKTORY A TOVÁRNÍ METODY =============================================

    /***************************************************************************
     * Vytvoří nový panel obsahující panely předmětů a sousedů
     * aktuální místnosti.
     */
    public PanelMístností()
    {
        super(BoxLayout.Y_AXIS);
        add(panelPředmětů);
        add(Box.createGlue());  //Odtlačí oba panely ke krajům pole
        add(panelSousedů);
    }



//== ABSTRAKTNÍ METODY =========================================================
//== PŘÍSTUPOVÉ METODY VLASTNOSTÍ INSTANCÍ =====================================
//== OSTATNÍ NESOUKROMÉ METODY INSTANCÍ ========================================

    /***************************************************************************
     * Inicializuje panel pro práci s novou hrou.
     *
     * @param hra Hra, s níž bude panel od této chvíle komunikovat
     */
    public void inicializuj(IGameG hra)
    {
        panelPředmětů.inicializuj(hra);
        panelSousedů .inicializuj(hra);
    }



//== SOUKROMÉ A POMOCNÉ METODY TŘÍDY ===========================================
//== SOUKROMÉ A POMOCNÉ METODY INSTANCÍ ========================================
//== INTERNÍ DATOVÉ TYPY =======================================================
//== TESTY A METODA MAIN =======================================================
//
//    /***************************************************************************
//     * Testovací metoda.
//     */
//    public static void test()
//    {
//        PanelMístností inst = new PanelMístností();
//    }
//    /** @param args Parametry příkazového řádku - nepoužívané. */
//    public static void main( String[] args )  {  test();  }
}
