/* Soubor je ulozen v kodovani UTF-8.
 * Kontrola kódování: Příliš žluťoučký kůň úpěl ďábelské ódy.
 */
package cz.pecinovsky.english.pojj.adv_framework.test_util.default_gui;

import cz.pecinovsky.english.pojj.adv_framework.game_gui.IGameG;
import cz.pecinovsky.english.pojj.adv_framework.game_gui.IPlaceG;

import java.util.ArrayList;
import java.util.Collection;



/*******************************************************************************
 * Instance třídy {@code PanelSousedů} představují panely,
 * v nichž se v průběhu hry zobrazují sousedé aktuální místnosti,
 * tj místností, do nichž je možno z aktuální mísntosti přímo přejít.
 * <br><br>
 * Třída je upravena tak, aby její instance uměly pracovat s prvky
 * definovanými jako tlačítka, jejichž stiskem lze hráče přesunout
 * do příslušné místnosti.
 * K tomu bylo třeba přidat atributy pro zapamatování si příkazu k přejítí
 * a také GUI, jehož prostřednictvím bude příkaz hře zadán.
 *
 * @author    Rudolf PECINOVSKÝ
 * @version   0.00.000
 */
@SuppressWarnings("serial")
class PanelSousedůBtn extends APanelPrvků<IPlaceG>
{
//== KONSTANTNÍ ATRIBUTY TŘÍDY =================================================
//== PROMĚNNÉ ATRIBUTY TŘÍDY ===================================================
//== STATICKÝ INICIALIZAČNÍ BLOK - STATICKÝ KONSTRUKTOR ========================
//== KONSTANTNÍ ATRIBUTY INSTANCÍ ==============================================

    /** GUI, prostřednictvím nějž je hra ovládána. */
    private final IMojeGUI gui;



//== PROMĚNNÉ ATRIBUTY INSTANCÍ ================================================

    /** Příkaz, jímž se v aktuálně zpracovávané hře
     *  přesouvá do zadané místnosti. */
    private String příkazPřesuň;



//== PŘÍSTUPOVÉ METODY VLASTNOSTÍ TŘÍDY ========================================
//== OSTATNÍ NESOUKROMÉ METODY TŘÍDY ===========================================

//##############################################################################
//== KONSTRUKTORY A TOVÁRNÍ METODY =============================================

    /***************************************************************************
     * Vytvoří nový panel pro zobrazování sousedů aktuální místnosti.
     *
     * @param gui  GUI, prostřednictvím nějž je hra ovládána
     */
    PanelSousedůBtn(IMojeGUI gui)
    {
        super("Aktuální sousedé");
        this.gui = gui;
    }



//== ABSTRAKTNÍ METODY =========================================================
//== PŘÍSTUPOVÉ METODY VLASTNOSTÍ INSTANCÍ =====================================
//== OSTATNÍ NESOUKROMÉ METODY INSTANCÍ ========================================

    /***************************************************************************
     * Hlášeni o změně sousedů aktuální místnosti zapříčiněné
     * buď jejich přímým přidáním či odebráním, anebo změnou místnosti.
     *
     * @param aktuální Místnost, jejíž sousedy je třeba zobrazit
     */
    @Override
    public void notice(IPlaceG aktuální)
    {
        Collection<PrvekPaneluBtn> prvky = new ArrayList<PrvekPaneluBtn>();
        for (IPlaceG místnost : aktuální.getNeighbors()) {
            PrvekPaneluBtn pp = new PrvekPaneluBtn(místnost, příkazPřesuň, gui);
            prvky.add(pp);
        }
        zpracujHlášení(prvky);
    }


    /***************************************************************************
     * Inicializuje panel pro práci s novou hrou.
     *
     * @param hra Hra, s níž bude panel od této chvíle komunikovat
     */
    @Override
    public void inicializuj(IGameG hra)
    {
        příkazPřesuň = hra.getBasicCommands().cMOVE;
        hra.addNeighborsListener(this);
        notice(hra.getActualPlace());
    }



//== SOUKROMÉ A POMOCNÉ METODY TŘÍDY ===========================================
//== SOUKROMÉ A POMOCNÉ METODY INSTANCÍ ========================================
//== INTERNÍ DATOVÉ TYPY =======================================================
//== TESTY A METODA MAIN =======================================================
//
//    /***************************************************************************
//     * Testovací metoda.
//     */
//    public static void test()
//    {
//        PanelSousedů inst = new PanelSousedů();
//    }
//    /** @param args Parametry příkazového řádku - nepoužívané. */
//    public static void main( String[] args )  {  test();  }
}
